#!/usr/bin/python
# coding: utf8
#############################################
#                                           #
# ██  ██  ████  █████   ████  █   ██ ██████ #
# ██  ██ ██  ██ ██  ██ ██  ██ ██  ██ ██     #
# ██ ██  ██  ██ ██  ██ ██  ██ ███ ██ ██     #
# ████   ██  ██ █████  ██  ██ ██████ █████  #
# ██ ██  ██  ██ ██  ██ ██  ██ ██ ███ ██     #
# ██  ██ ██  ██ ██  ██ ██  ██ ██  ██ ██     #
# ██  ██  ████  █████   ████  ██   █ ██████ #
#                                           #
#############################################
#############################################
# KOBO Notes Extractor                      #
# author:                                   #
# bronco@warriordudimanche.net              #
# version: 1.0                              #
#############################################
########################
#                      #
#  ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   #
#   ▒▒   ▒▒▒▒▒▒   ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒   #
#  ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒  #
#                      #
########################


#####################################################
#                                                   #
#  ▒▒▒▒  ▒     ▒ ▒▒▒▒▒   ▒▒▒▒  ▒▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒   ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒ ▒▒   ▒ #
#   ▒▒   ▒▒▒ ▒▒▒ ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒    ▒▒     ▒▒   #
#   ▒▒   ▒▒ ▒ ▒▒ ▒▒     ▒▒  ▒▒ ▒▒  ▒▒   ▒▒   ▒   ▒▒ #
#  ▒▒▒▒  ▒▒   ▒▒ ▒▒      ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒   ▒▒▒▒  #
#                                                   #
#####################################################
import sqlite3
import os
import json
# GTK
import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk

##################################################################
#                                                                #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒▒  ▒▒  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒   ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒   ▒▒   ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒   ▒ #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒▒▒▒   ▒▒   #
# ▒▒     ▒▒  ▒▒ ▒▒ ▒▒▒ ▒▒  ▒▒   ▒▒     ▒▒   ▒▒  ▒▒ ▒▒ ▒▒▒ ▒   ▒▒ #
# ▒▒      ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒   ▒▒▒▒   ▒▒▒▒   ▒▒▒▒  ▒▒  ▒▒  ▒▒▒▒  #
#                                                                #
##################################################################

# saveJson function
def save(filename,data):
	f = open(filename, 'w')
	f.write(data)
	f.close()

# aff(var)
def aff(var):
    import pprint
    pprint.pprint(var)

def update_progress(bar,i):
        bar.pulse ()
        bar.set_fraction (i/100.0) 
        bar.set_text(str(i))
        return 

def extract():
    """Extract notes from Kobo database"""
    # Init
    # GET VALUES FROM WIN

    format      = formatList.get_active_text()
    koboDBFilePath   = koboPath.get_text()
    personnalOutputFormat   = personnalFormat.get_text()
    #koboDBFilePath   = "/home/eric/Bureau/KoboReader.sqlite"
    minQuoteLength   = int(lessThan.get_text())
    maxQuoteLength   = int(moreThan.get_text())
    bool_keepWithout= keepWithout.get_active()
    bool_keepWith   = keepWith.get_active()
    update_progress(progressBar, 0);

    formats={
        "HTML":"<section><cite>%quote</cite><blockquote>%annotation</blockquote><p><em>%title</em></p></section>",
        "MD":"###%quote\n####%annotation\n*%title* ***\n",
        "JSON":'{'+"citation:%quote,title:%title,note:%annotation"+'}',
        "TXT":"*TEXTE:%quote\n*NOTE:%annotation\n*TITRE:%title ***\n",
        "RAW":"%quote\n%annotation\n(%title)\n\n",
        "BOT":"%quote\n(%title)***\n\n",
    }

    if personnalOutputFormat!='':
        format_string=personnalOutputFormat.replace('\\n',"\n")
        format="txt"        
    else:
        format_string=formats[format]

    outputFile = outputFileName.get_text()+'notes_de_lecture.'+format

    if os.path.isfile(koboDBFilePath)==False:
        aff("error:"+koboDBFilePath)
    	
    # DB extract
    db = sqlite3.connect(koboDBFilePath)
    notes = db.execute("SELECT ContentID,Text,Annotation FROM Bookmark")
    books = db.execute("SELECT ContentID,BookTitle FROM content")
    books = books.fetchall()
    notes = notes.fetchall()
    
    # Create dict with ID:title
    booksdata = {}
    for book in books:
        booksdata[book[0]] = book[1]

    data = []
    nb=len(notes)
    current=0

    for line in notes:
        current+=1
        progress=(current*100)/nb
        update_progress(progressBar,progress)

        if line[1]:
            title = ''
            annotation = ''
            quote = line[1]

            if line[2]:
                annotation = line[2]

            if line[0] and booksdata[line[0]]:
                title = booksdata[line[0]]

            keep= (bool_keepWith and bool_keepWithout) or (annotation and bool_keepWith) or (annotation=="" and bool_keepWithout) 

            if keep and len(quote)>minQuoteLength and len(quote)<maxQuoteLength:
                temp=format_string.replace('%title',title)
                temp=temp.replace('%annotation',annotation)
                temp=temp.replace('%quote',quote)
                data.append(temp)
                

    if format=="JSON":
    	save(outputFile,json.dumps(data))
    else:
    	save(outputFile,"\n".join(data))

    progressBar.set_text("Saved !")
#############################################
#                                           #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒  ▒▒ ▒▒▒▒▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒     ▒▒▒ ▒▒ ▒ ▒▒ ▒ ▒▒   ▒ #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒  ▒▒▒▒▒▒   ▒▒     ▒▒   #
# ▒▒      ▒▒▒▒  ▒▒     ▒▒ ▒▒▒   ▒▒   ▒   ▒▒ #
# ▒▒▒▒▒▒   ▒▒   ▒▒▒▒▒▒ ▒▒  ▒▒  ▒▒▒▒   ▒▒▒▒  #
#                                           #
#############################################


class events:
    def onDestroy(self, *args):
        Gtk.main_quit()

    def extractButtonClicked(self, button):
        extract()


########################
#                      #
# ▒▒  ▒▒ ▒▒  ▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒  ▒▒ ▒▒     #
# ▒▒  ▒▒ ▒▒  ▒▒ ▒▒▒▒▒  #
#  ▒▒▒▒  ▒▒  ▒▒ ▒▒     #
#   ▒▒    ▒▒▒▒  ▒▒▒▒▒▒ #
#                      #
########################
builder = Gtk.Builder()
builder.add_from_file("frame.glade")
builder.connect_signals(events())
window = builder.get_object('mainFrame')
formatList = builder.get_object('outputFormatList')
koboPath = builder.get_object('koboPath')
personnalFormat = builder.get_object('personnalFormat')
progressBar = builder.get_object('progressBar')
outputFileName = builder.get_object('outputFileName')
lessThan = builder.get_object('lessThan')
moreThan = builder.get_object('moreThan')
keepWith = builder.get_object('keepWith')
keepWithout = builder.get_object('keepWithout')

window.show_all()


########################
#                      #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒  ▒▒ ▒▒  ▒▒ ▒▒▒ ▒▒ #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒  ▒▒ ▒▒ ▒▒▒ #
# ▒▒  ▒▒  ▒▒▒▒  ▒▒  ▒▒ #
#                      #
########################
Gtk.main()  # essentiel pour lancer la boucle
